/* generate.c - random SML/NG text - Don Yang / Dave Newquist / John Rapp

   07/28/01
                                                                           */

#include<ctype.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>


#define SIZE_LIMIT      8000
#define TAG_COUNT       24

static char *Tag[TAG_COUNT] = {
   "EM", "B", "I", "S", "TT", "U",
   "c", "m", "y", "k", "r", "g", "b", "w",
   "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"};
static char *Text = "abcijkxyz01   \n\t";
static int Size;

/******************************************************************* block */
static void block(int level)
{
   int i, j;

   if( level > 7 )
      return;

   for(i = 0; i < 4 + (rand() & 3); i++)
   {
      if( Size++ > SIZE_LIMIT )
         return;
      if( rand() & 1 )
      {
         j = rand() % TAG_COUNT;
         printf("<%s>", Tag[j]);
         block(level + 1);
         printf("</%s>", Tag[j]);
      }
      else
      {
         putchar(Text[rand() & 15]);
      }
   }

} /* block() */

/******************************************************************** main */
int main(void)
{
   srand((unsigned)time(NULL));

   block(Size = 0);

   return 0;

} /* main() */
