/* o_pl.c - PL optimization - Don Yang / Dave Newquist / John Rapp

   07/28/01
                                                                           */

#include<assert.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include"smlng.h"
#include"token.h"
#include"tree.h"


/************************************************************** o_pl_short */
int o_pl_short(Node **node)
{
   Attr *attr;
   int modified;

   modified = 0;
   while( *node )
   {
      if( (*node)->token->type == TagPL )
      {
         attr = &((*node)->attr);
         if( !attr->tt && !attr->b && !attr->i && !attr->s && !attr->em &&
             attr->u == 0 )
         {
            PromoteSubtree(node);
            modified = 1;
            continue;
         }
      }
      if( (*node)->tree )
         modified |= o_pl_short(&((*node)->tree));
      node = &((*node)->next);
   }

   return modified;

} /* o_pl_short() */
